"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.evaluateIdentifier = void 0;
const create_result_pair_1 = require("../../../../create-result-pair");
const resolve_binding_1 = require("../../../../resolve-binding");
const evaluateIdentifier = (expression, meta, evaluateExpression) => {
    const { name } = expression;
    const resolvedBinding = (0, resolve_binding_1.resolveBinding)(name, meta, evaluateExpression);
    if (resolvedBinding) {
        const { constant, node, meta: updatedMeta } = resolvedBinding;
        if (constant && node) {
            return (0, create_result_pair_1.createResultPair)(node, updatedMeta);
        }
    }
    return (0, create_result_pair_1.createResultPair)(expression, meta);
};
exports.evaluateIdentifier = evaluateIdentifier;
//# sourceMappingURL=identifier.js.map